//anti turret pack, when mounted keeps users from taking damage from any turret.
//------------------------------------------------------------------------------

datablock AudioProfile(AntiEnergyPackActivateSound)
{
filename = "fx/packs/shield_on.wav";
description = ClosestLooping3d;
preload = true;
};

datablock ShapeBaseImageData(AntiEnergyPackImage)
{
shapeFile = "pack_upgrade_shield.dts";
item = AntiEnergyPack;
mountPoint = 1;
offset = "0 0 0";

usesEnergy = false;
minEnergy = 3;

stateName[0] = "default";
stateSequence[0] = "activation";

};

datablock ItemData(AntiEnergyPack)
{
className = Pack;
catagory = "Packs";
shapeFile = "pack_upgrade_shield.dts";
mass = 1;
elasticity = 0.2;
friction = 0.6;
pickupRadius = 2;
rotate = true;
image = "AntiEnergyPackImage";
pickUpName = "an Anti Turret pack";

computeCRC = true;
};

function AntiEnergyPackImage::onMount(%data, %obj, %node)
{
messageClient(%obj.client, 'MsgAntiEnergyPackOn', '\c2you are now shielded from turret damage.');
%obj.antiEnergy = true; //Variable for antienergy pack
Parent::onMount(%this,%obj,%slot);
CommandToClient(%obj.client, 'CenterPrint', "Anti Turret Pack - when mounted protects user from turret damage, ELF+EMP still draw energy.", 4, 2 );
}

function AntiEnergyPackImage::onUnmount(%data, %obj, %node)
{
messageClient(%obj.client, 'MsgAntiEnergyPackOff', '\c2anti turret pack off.');
%obj.setImageTrigger(%node, false);
%obj.antiEnergy = ""; //Variable for antienergy pack
}

function AntiEnergyPack::onPickup(%this, %obj, %shape, %amount)
{
// created to prevent console errors
}