// ------------------------------------------------------------------------
// EMP grenade originally sticky bomb hence the name of the datablocks- RED
// ------------------------------------------------------------------------
datablock EffectProfile(GrenadeThrowEffect)
{
   effectname = "weapons/grenade_throw";
   minDistance = 2.5;
   maxDistance = 2.5;
};

datablock EffectProfile(GrenadeSwitchEffect)
{
   effectname = "weapons/generic_switch";
   minDistance = 2.5;
   maxDistance = 2.5;
};

datablock AudioProfile(StickyBombExplosionSound)
{
   filename    = "fx/powered/turret_sentry_impact.wav";
   description = AudioExplosion3d;
   preload = true;
   effect = GrenadeExplosionEffect;
};
//shockwave

datablock ShockwaveData(StickyBombShockwave)
{
   width = 6.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 10;
   acceleration = 15.0;
   lifetimeMS = 750;
   height = 1.0;
   verticalCurve = 0.5;
   is2D = true;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.0 0.0 0.9 1.0";
   colors[1] = "0.0 0.0 0.9 1.0";
   colors[2] = "0.9 0.9 0.9 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = false;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------


datablock ParticleData( StickyCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.0 0.1 0.9 1.0";
   colors[1]     = "0.0 0.1 0.9 1.0";
   colors[2]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
   sizes[2]      = 1.6;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( StickyCrescentEmitter )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 38;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "StickyCrescentParticle";
};

datablock ParticleData( StickyCrescent2Particle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.0 0.0 0.9 1.0";
   colors[1]     = "0.0 0.0 0.9 1.0";
   colors[2]     = "0.0 0.0 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
   sizes[2]      = 1.6;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( StickyCrescent2Emitter )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 35;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "StickyCrescent2Particle";
};

datablock ParticleData(StickyBombExplosionParticle1)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent4";
   colors[0] = "0.0 0.3 0.9 1.0";
   colors[1] = "0.9 0.9 0.9 1.0";
   colors[2] = "0.3 0.3 0.9 0.0";
   sizes[0]      = 4.5;
   sizes[1]      = 9.0;
   sizes[2]      = 18.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(StickyBombExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.5;
   ejectionOffset   = 0.0;
   thetaMin         = 70;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "StickyBombExplosionParticle1";
};

datablock ParticleData(StickyBombExplosionParticle2)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent4";
   colors[0] = "0.0 0.9 0.3 1.0";
   colors[1] = "0.9 0.9 0.9 1.0";
   colors[2] = "0.0 0.9 0.3 0.0";
   sizes[0]      = 5.0;
   sizes[1]      = 10.0;
   sizes[2]      = 15.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(StickyBombExplosionEmitter2)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 200;
   particles = "StickyBombExplosionParticle2";
};

datablock ExplosionData(StickyBombExplosion)
{
   soundProfile   = StickyBombExplosionSound;

   shockwave = StickyBombShockwave;
   shockwaveOnTerrain = false;

   emitter[0]     = StickyBombExplosionEmitter;
   emitter[1]     = StickyBombExplosionEmitter2;
   emitter[2]     = StickyCrescentEmitter;
   emitter[3]     = StickyCrescent2Emitter;
};

datablock ItemData(StickyBombThrown)
{
	className = Weapon;
	shapeFile = "grenade.dts";
        scale               = "3.0 3.0 3.0";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 2;
   maxDamage = 0.5;
        explosion = StickyBombExplosion;
	underwaterExplosion = StickyBombExplosion;
   
   indirectDamage      = 0.4;
   damageRadius        = 15.5;
   radiusDamageType    = $DamageType::EMP;
   kickBackStrength    = 100;
   
   computeCRC = true;
   sticky = false;

};

datablock ItemData(StickyBomb)
{
	className = HandInventory;
	catagory = "Handheld";
	shapeFile = "grenade.dts";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 2;
   thrownItem = StickyBombThrown;
	pickUpName = "some EMP grenades";
	isGrenade = true;

   computeCRC = true;

};

function StickyBombThrown::onThrow(%this, %gren, %obj)
{
AIGrenadeThrown(%gren);
%gren.detThread = schedule(2000, %gren, "detonateGrenade", %gren);
}
