//------------------------------------------------------------------------------------
//Heavy laser, high powered laser rifle that needs a 3 second charge before firing-RED
//------------------------------------------------------------------------------------
datablock AudioProfile(LaserDelaySound)
{
   filename    = "fx/misc/downloading.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(HeavyLaserSwitchSound)
{
   filename    = "fx/armor/med_LF_metal.WAV";
   description = AudioClosest3d;
   preload = true;
   effect = SniperRifleSwitchEffect;
};

datablock AudioProfile(HeavyLaserFireSound)
{
   filename    = "fx/powered/turret_aa_fire.wav";
   description = AudioClose3d;
   preload = true;
   effect = SniperRifleFireEffect;
};

datablock AudioProfile(HeavyLaserExplosionSound)
{
   filename    = "fx/weapons/spinfusor_impact_UW.wav";
   description = AudioClosest3d;
   preload = true;
};

//--------------------------------------------------------------------------
// HeavyLaser Particle effects
//--------------------------------------
datablock ParticleData( HeavyLaserCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.0 0.8 0.0 1.0";
   colors[1]     = "0.0 0.8 0.0 0.5";
   colors[2]     = "0.0 0.8 0.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 2.0;
   sizes[2]      = 2.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( HeavyLaserCrescentEmitter )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "HeavyLaserCrescentParticle";
};

datablock ParticleData( HeavyLaserCrescentParticle2 )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.0 0.8 0.0 1.0";
   colors[1]     = "0.0 0.8 0.0 0.5";
   colors[2]     = "0.0 0.8 0.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 2.0;
   sizes[2]      = 2.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( HeavyLaserCrescentEmitter2 )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "HeavyLaserCrescentParticle2";
};

datablock ParticleData( HeavyLaserCrescentParticle3 )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.0 0.8 0.0 1.0";
   colors[1]     = "0.0 0.8 0.0 0.5";
   colors[2]     = "0.0 0.8 0.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 2.0;
   sizes[2]      = 2.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( HeavyLaserCrescentEmitter3 )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "HeavyLaserCrescentParticle3";
};

datablock ParticleData( HeavyLaserCrescentParticle4 )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.7 0.8 0.0 1.0";
   colors[1]     = "0.7 0.8 0.0 0.5";
   colors[2]     = "0.7 0.8 0.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 2.0;
   sizes[2]      = 2.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( HeavyLaserCrescentEmitter4 )
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "HeavyLaserCrescentParticle4";
};

datablock ExplosionData(HeavyLaserExplosion)
{
   explosionShape = "energy_explosion.dts";
   soundProfile   = HeavyLaserExplosionSound;

   emitter[0] = HeavyLaserCrescentEmitter;
   emitter[1] = HeavyLaserCrescentEmitter2;
   emitter[2] = HeavyLaserCrescentEmitter3;
   emitter[3] = HeavyLaserCrescentEmitter4;

   shakeCamera = false;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

//--------------------------------------
// Projectile
//--------------------------------------
datablock SniperProjectileData(HeavyLaserSniperShot)
{
   directDamage        = 1.2;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "HeavyLaserExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::HLaser;

   maxRifleRange       = 1000;
   rifleHeadMultiplier = 2;
   beamColor           = "0.0 0.9 0.0";
   fadeTime            = 1.0;

   startBeamWidth		  = 0.29;
   endBeamWidth 	     = 0.50;
   pulseBeamWidth 	  = 1.0;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "0.0 0.9 0.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/laserrip01";
   textureName[3]      = "special/laserrip02";
   textureName[4]      = "special/laserrip03";
   textureName[5]      = "special/laserrip04";
   textureName[6]      = "special/laserrip05";
   textureName[7]      = "special/laserrip06";
   textureName[8]      = "special/laserrip07";
   textureName[9]      = "special/laserrip08";
   textureName[10]     = "special/laserrip09";
   textureName[11]     = "special/sniper00";

};


//--------------------------------------
// Rifle and item...
//--------------------------------------
datablock ItemData(HeavyLaser)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_sniper.dts";
   image        = HeavyLaserImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a heavy laser rifle";

   computeCRC = true;

};

datablock ShapeBaseImageData(HeavyLaserImage)
{
	className = WeaponImage;
   shapeFile = "weapon_sniper.dts";
   item = HeavyLaser;
   projectile = HeavyLaserSniperShot;
   projectileType = SniperProjectile;

	usesEnergy = true;
	minEnergy = 6;
        
   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = HeavyLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Delay";

   stateName[3] = "Delay";
   stateTimeoutValue[3] = 3.0; // --- Wait for 3 seconds
   stateSound[3] = LaserDelaySound;
   stateTransitionOnTimeout[3] = "Fire";

   stateName[4]                     = "Fire";
   stateTransitionOnTimeout[4]      = "Reload";
   stateTimeoutValue[4]             = 0.5;
   stateFire[4]                     = true;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Fire";
   stateScript[4]                   = "onFire";

   stateName[5]                     = "Reload";
   stateTransitionOnTimeout[5]      = "Ready";
   stateTimeoutValue[5]             = 0.5;
   stateAllowImageChange[5]         = false;
   
   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";
   
   stateName[7]                     = "DryFire";
   stateSound[7]                    = SniperRifleDryFireSound;
   stateTimeoutValue[7]             = 0.5;
   stateTransitionOnTimeout[7]      = "Ready";
};

datablock ShapeBaseImageData(HeavyLaserImage2) :HeavyLaserImage 
{ 
shapeFile = "weapon_disc.dts";
offset = "0 0 0";
rotation = "0 0 0 ";
}; 

function HeavyLaserImage::onMount(%this,%obj,%slot) 
{ 
%obj.mountImage(HeavyLaserImage2,$AuxiliarySlot); 
Parent::onMount(%this,%obj,%slot); 
} 

function HeavyLaserImage::onUnmount(%this, %obj, %slot) 
{ 
%obj.unmountImage($AuxiliarySlot); 
Parent::onMount(%this,%obj,%slot); 
} 

function HeavyLaserImage::onFire(%data,%obj,%slot)
{
   if(!%obj.hasEnergyPack)
   {
      // siddown Junior, you can't use it
      serverPlay3D(SniperRifleDryFireSound, %obj.getTransform());
      return;
   }
   
   %pct = %obj.getEnergyLevel() / %obj.getDataBlock().maxEnergy;
   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      damageFactor     = %pct * %pct;
      sourceSlot       = %slot;
   };
   %p.setEnergyPercentage(%pct);

   %obj.lastProjectile = %p;
   MissionCleanup.add(%p);
   serverPlay3D(HeavyLaserFireSound, %obj.getTransform());
   
   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.setEnergyLevel(0);
}