

/////////////////////////////////////////////////////////////////////////////////////////////////
// %1 = Victim's name                                                                          //
// %2 = Victim's gender (value will be either "him" or "her")                                  //
// %3 = Victim's possessive gender	(value will be either "his" or "her")                      //
// %4 = Killer's name                                                                          //
// %5 = Killer's gender (value will be either "him" or "her")                                  //
// %6 = Killer's possessive gender (value will be either "his" or "her")                       //
// %7 = implement that killed the victim (value is the object number of the bullet, disc, etc) //
/////////////////////////////////////////////////////////////////////////////////////////////////

$DeathMessageCampingCount = 1;
$DeathMessageCamping[0] = '\c0%1 was killed for camping near the Nexus.';
																						   
 //Out of Bounds deaths
$DeathMessageOOBCount = 1;
$DeathMessageOOB[0] = '\c0%1 was killed for loitering outside the mission area.';

$DeathMessageLavaCount = 4;
$DeathMessageLava[0] = '\c0%1\'s last thought before falling into the lava : \'Oops\'.';
$DeathMessageLava[1] = '\c0%1 makes the supreme sacrifice to the lava gods.';
$DeathMessageLava[2] = '\c0%1 looks surprised by the lava - but only briefly.';
$DeathMessageLava[3] = '\c0%1 wimps out by jumping into the lava and trying to make it look like an accident.'; 

$DeathMessageLightningCount = 3;
$DeathMessageLightning[0] = '\c0%1 was killed by lightning!';
$DeathMessageLightning[1] = '\c0%1 caught a lightning bolt!';
$DeathMessageLightning[2] = '\c0%1 stuck %3 finger in Mother Nature\'s light socket.';

//these used when a player presses ctrl-k
$DeathMessageSuicideCount = 5;
$DeathMessageSuicide[0] = '\c0%1 blows %3 own head off!';  
$DeathMessageSuicide[1] = '\c0%1 ends it all. Cue violin music.';
$DeathMessageSuicide[2] = '\c0%1 kills %2self.';
$DeathMessageSuicide[3] = '\c0%1 goes for the quick and dirty respawn.';
$DeathMessageSuicide[4] = '\c0%1 self-destructs in a fit of ennui.';

$DeathMessageVehPadCount = 1;
$DeathMessageVehPad[0] = '\c0%1 got caught in a vehicle\'s spawn field.'; 

$DeathMessageFFPowerupCount = 1;
$DeathMessageFFPowerup[0] = '\c0%1 got caught up in a forcefield during power up.'; 

$DeathMessageRogueMineCount = 1;
$DeathMessageRogueMine[$DamageType::Mine, 0] = '\c0%1 is all mine.';

//these used when a player kills himself (other than by using ctrl - k)
$DeathMessageSelfKillCount = 5;
$DeathMessageSelfKill[$DamageType::Blaster, 0] = '\c0%1 kills %2self with a blaster.';	
$DeathMessageSelfKill[$DamageType::Blaster, 1] = '\c0%1 makes a note to watch out for blaster ricochets.';
$DeathMessageSelfKill[$DamageType::Blaster, 2] = '\c0%1\'s blaster kills its hapless owner.';
$DeathMessageSelfKill[$DamageType::Blaster, 3] = '\c0%1 deftly guns %2self down with %3 own blaster.';
$DeathMessageSelfKill[$DamageType::Blaster, 4] = '\c0%1 has a fatal encounter with %3 own blaster.';

$DeathMessageSelfKill[$DamageType::Plasma, 0] = '\c0%1 kills %2self with plasma.';
$DeathMessageSelfKill[$DamageType::Plasma, 1] = '\c0%1 turns %2self into plasma-charred briquettes.';
$DeathMessageSelfKill[$DamageType::Plasma, 2] = '\c0%1 swallows a white-hot mouthful of %3 own plasma.';
$DeathMessageSelfKill[$DamageType::Plasma, 3] = '\c0%1 immolates %2self.';
$DeathMessageSelfKill[$DamageType::Plasma, 4] = '\c0%1 experiences the joy of cooking %2self.';

$DeathMessageSelfKill[$DamageType::Disc, 0] = '\c0%1 kills %2self with a disc.';
$DeathMessageSelfKill[$DamageType::Disc, 1] = '\c0%1 catches %3 own spinfusor disc.';
$DeathMessageSelfKill[$DamageType::Disc, 2] = '\c0%1 heroically falls on %3 own disc.';
$DeathMessageSelfKill[$DamageType::Disc, 3] = '\c0%1 helpfully jumps into %3 own disc\'s explosion.';
$DeathMessageSelfKill[$DamageType::Disc, 4] = '\c0%1 plays Russian roulette with %3 spinfusor.';

$DeathMessageSelfKill[$DamageType::Grenade, 0] = '\c0%1 destroys %2self with a grenade!';   //applies to hand grenades *and* grenade launcher grenades
$DeathMessageSelfKill[$DamageType::Grenade, 1] = '\c0%1 took a bad bounce from %3 own grenade!';
$DeathMessageSelfKill[$DamageType::Grenade, 2] = '\c0%1 pulled the pin a shade early.';
$DeathMessageSelfKill[$DamageType::Grenade, 3] = '\c0%1\'s own grenade turns on %2.';
$DeathMessageSelfKill[$DamageType::Grenade, 4] = '\c0%1 blows %2self up real good.';

$DeathMessageSelfKill[$DamageType::Mortar, 0] = '\c0%1 kills %2self with a mortar!';
$DeathMessageSelfKill[$DamageType::Mortar, 1] = '\c0%1 hugs %3 own big green boomie.';
$DeathMessageSelfKill[$DamageType::Mortar, 2] = '\c0%1 mortars %2self all over the map.';
$DeathMessageSelfKill[$DamageType::Mortar, 3] = '\c0%1 experiences %3 mortar\'s payload up close.';
$DeathMessageSelfKill[$DamageType::Mortar, 4] = '\c0%1 suffered the wrath of %3 own mortar.';

$DeathMessageSelfKill[$DamageType::Missile, 0] = '\c0%1 kills %2self with a missile!';
$DeathMessageSelfKill[$DamageType::Missile, 1] = '\c0%1 runs a missile up %3 own tailpipe.';
$DeathMessageSelfKill[$DamageType::Missile, 2] = '\c0%1 tests the missile\'s shaped charge on %2self.';
$DeathMessageSelfKill[$DamageType::Missile, 3] = '\c0%1 achieved missile lock on %2self.';
$DeathMessageSelfKill[$DamageType::Missile, 4] = '\c0%1 gracefully smoked %2self with a missile!';

$DeathMessageSelfKill[$DamageType::Mine, 0] = '\c0%1 kills %2self with a mine!';
$DeathMessageSelfKill[$DamageType::Mine, 1] = '\c0%1\'s mine violently reminds %2 of its existence.';
$DeathMessageSelfKill[$DamageType::Mine, 2] = '\c0%1 plants a decisive foot on %3 own mine!';
$DeathMessageSelfKill[$DamageType::Mine, 3] = '\c0%1 fatally trips on %3 own mine!';
$DeathMessageSelfKill[$DamageType::Mine, 4] = '\c0%1 makes a note not to run over %3 own mines.';

$DeathMessageSelfKill[$DamageType::SatchelCharge, 0] = '\c0%1 goes out with a bang!';  //applies to most explosion types
$DeathMessageSelfKill[$DamageType::SatchelCharge, 1] = '\c0%1 fall down...go boom.';
$DeathMessageSelfKill[$DamageType::SatchelCharge, 2] = '\c0%1 explodes in that fatal kind of way.';
$DeathMessageSelfKill[$DamageType::SatchelCharge, 3] = '\c0%1 experiences explosive decompression!';
$DeathMessageSelfKill[$DamageType::SatchelCharge, 4] = '\c0%1 splashes all over the map.';

$DeathMessageSelfKill[$DamageType::Ground, 0] = '\c0%1 lands too hard.';
$DeathMessageSelfKill[$DamageType::Ground, 1] = '\c0%1 finds gravity unforgiving.';
$DeathMessageSelfKill[$DamageType::Ground, 2] = '\c0%1 craters on impact.';
$DeathMessageSelfKill[$DamageType::Ground, 3] = '\c0%1 pancakes upon landing.';
$DeathMessageSelfKill[$DamageType::Ground, 4] = '\c0%1 loses a game of chicken with the ground.';

$DeathMessageSelfKill[$DamageType::Nuke, 0] = '\c0%1 kills %2self with a widow maker!';
$DeathMessageSelfKill[$DamageType::Nuke, 1] = '\c0%1 stood to close to %3 own widow maker.';
$DeathMessageSelfKill[$DamageType::Nuke, 2] = '\c0%1 needs to back up a little further when using %3 widow maker.';
$DeathMessageSelfKill[$DamageType::Nuke, 3] = '\c0%1 radiates %2self.';
$DeathMessageSelfKill[$DamageType::Nuke, 4] = '\c0%1 chars %2self beyond recognition with a widow maker.';

$DeathMessageSelfKill[$DamageType::Rail, 0] = '\c0%1 kills %2self with an RPG!';
$DeathMessageSelfKill[$DamageType::Rail, 1] = '\c0%1 commits suicide with the RPG.';
$DeathMessageSelfKill[$DamageType::Rail, 2] = '\c0%1 blows %2self to bits with the RPG.';
$DeathMessageSelfKill[$DamageType::Rail, 3] = '\c0%1 experiences %3 RPG up close and personal.';
$DeathMessageSelfKill[$DamageType::Rail, 4] = '\c0%1 finds out that %3 RPG needs to be used more cautiously.';

$DeathMessageSelfKill[$DamageType::Nape, 0] = '\c0%1 burns %2self to a crisp!';
$DeathMessageSelfKill[$DamageType::Nape, 1] = '\c0%1 commits suicide with some napalm.';
$DeathMessageSelfKill[$DamageType::Nape, 2] = '\c0%1 goes down in a blaze!';
$DeathMessageSelfKill[$DamageType::Nape, 3] = '\c0%1 kills %2self with napalm.';
$DeathMessageSelfKill[$DamageType::Nape, 4] = '\c0%1 uses %3 napalm to get a fast tan, too bad they dont make spf10000.';

$DeathMessageSelfKill[$DamageType::Storm, 0] = '\c0%1 surrounds %2self with a mortar storm.';
$DeathMessageSelfKill[$DamageType::Storm, 1] = '\c0%1 surrounds %2self with a mortar storm.';
$DeathMessageSelfKill[$DamageType::Storm, 2] = '\c0%1 surrounds %2self with a mortar storm.';
$DeathMessageSelfKill[$DamageType::Storm, 3] = '\c0%1 surrounds %2self with a mortar storm.';
$DeathMessageSelfKill[$DamageType::Storm, 4] = '\c0%1 surrounds %2self with a mortar storm.';

$DeathMessageSelfKill[$DamageType::Solar, 0] = '\c0%1 obliterates %2self with a solar charge.';
$DeathMessageSelfKill[$DamageType::Solar, 1] = '\c0%1 obliterates %2self with a solar charge.';
$DeathMessageSelfKill[$DamageType::Solar, 2] = '\c0%1 obliterates %2self with a solar charge.';
$DeathMessageSelfKill[$DamageType::Solar, 3] = '\c0%1 obliterates %2self with a solar charge.';
$DeathMessageSelfKill[$DamageType::Solar, 4] = '\c0%1 obliterates %2self with a solar charge.';

$DeathMessageSelfKill[$DamageType::Hornet, 0] = '\c0%1 kills %2self with a bazooka.';
$DeathMessageSelfKill[$DamageType::Hornet, 1] = '\c0%1 kills %2self with a bazooka.';
$DeathMessageSelfKill[$DamageType::Hornet, 2] = '\c0%1 kills %2self with a bazooka.';
$DeathMessageSelfKill[$DamageType::Hornet, 3] = '\c0%1 kills %2self with a bazooka.';
$DeathMessageSelfKill[$DamageType::Hornet, 4] = '\c0%1 kills %2self with a bazooka.';

$DeathMessageSelfKill[$DamageType::Slug, 0] = '\c0%1 took a bad ricochet from %3 own slug rifle.';
$DeathMessageSelfKill[$DamageType::Slug, 1] = '\c0%1 took a bad ricochet from %3 own slug rifle.';
$DeathMessageSelfKill[$DamageType::Slug, 2] = '\c0%1 took a bad ricochet from %3 own slug rifle.';
$DeathMessageSelfKill[$DamageType::Slug, 3] = '\c0%1 took a bad ricochet from %3 own slug rifle.';
$DeathMessageSelfKill[$DamageType::Slug, 4] = '\c0%1 took a bad ricochet from %3 own slug rifle.';

$DeathMessageSelfKill[$DamageType::Proton, 0] = '\c0%1 kills %2self with the dual proton blaster.';
$DeathMessageSelfKill[$DamageType::Proton, 1] = '\c0%1 kills %2self with the dual proton blaster.';
$DeathMessageSelfKill[$DamageType::Proton, 2] = '\c0%1 kills %2self with the dual proton blaster.';
$DeathMessageSelfKill[$DamageType::Proton, 3] = '\c0%1 kills %2self with the dual proton blaster.';
$DeathMessageSelfKill[$DamageType::Proton, 4] = '\c0%1 kills %2self with the dual proton blaster.';

$DeathMessageSelfKill[$DamageType::TimeBomb, 0] = '\c0%1 kills %2self with a time bomb.';
$DeathMessageSelfKill[$DamageType::TimeBomb, 1] = '\c0%1 kills %2self with a time bomb.';
$DeathMessageSelfKill[$DamageType::TimeBomb, 2] = '\c0%1 kills %2self with a time bomb.';
$DeathMessageSelfKill[$DamageType::TimeBomb, 3] = '\c0%1 kills %2self with a time bomb.';
$DeathMessageSelfKill[$DamageType::TimeBomb, 4] = '\c0%1 kills %2self with a time bomb.';

$DeathMessageSelfKill[$DamageType::Tactical, 0] = '\c0%1 kills %2self with a tactical nuke.';
$DeathMessageSelfKill[$DamageType::Tactical, 1] = '\c0%1 kills %2self with a tactical nuke.';
$DeathMessageSelfKill[$DamageType::Tactical, 2] = '\c0%1 kills %2self with a tactical nuke.';
$DeathMessageSelfKill[$DamageType::Tactical, 3] = '\c0%1 kills %2self with a tactical nuke.';
$DeathMessageSelfKill[$DamageType::Tactical, 4] = '\c0%1 kills %2self with a tactical nuke.';

$DeathMessageSelfKill[$DamageType::Lantern, 0] = '\c0%1 will remember next time to get out of the way of %6 Green Lantern Bomb.';
$DeathMessageSelfKill[$DamageType::Lantern, 1] = '\c0%1 will remember next time to get out of the way of %6 Green Lantern Bomb.';
$DeathMessageSelfKill[$DamageType::Lantern, 2] = '\c0%1 will remember next time to get out of the way of %6 Green Lantern Bomb.';
$DeathMessageSelfKill[$DamageType::Lantern, 3] = '\c0%1 will remember next time to get out of the way of %6 Green Lantern Bomb.';
$DeathMessageSelfKill[$DamageType::Lantern, 4] = '\c0%1 will remember next time to get out of the way of %6 Green Lantern Bomb.';

//used when a player is killed by a teammate 
$DeathMessageTeamKillCount = 1;	
$DeathMessageTeamKill[$DamageType::Blaster, 0] = '\c0%4 TEAMKILLED %1 with a blaster!';
$DeathMessageTeamKill[$DamageType::Plasma, 0] = '\c0%4 TEAMKILLED %1 with a plasma rifle!';
$DeathMessageTeamKill[$DamageType::Bullet, 0] = '\c0%4 TEAMKILLED %1 with a chaingun!';
$DeathMessageTeamKill[$DamageType::Disc, 0] = '\c0%4 TEAMKILLED %1 with a spinfusor!';
$DeathMessageTeamKill[$DamageType::Grenade, 0] = '\c0%4 TEAMKILLED %1 with a grenade!';
$DeathMessageTeamKill[$DamageType::Laser, 0] = '\c0%4 TEAMKILLED %1 with a laser rifle!';
$DeathMessageTeamKill[$DamageType::Elf, 0] = '\c0%4 TEAMKILLED %1 with an ELF projector!';
$DeathMessageTeamKill[$DamageType::Mortar, 0] = '\c0%4 TEAMKILLED %1 with a mortar!';
$DeathMessageTeamKill[$DamageType::Missile, 0] = '\c0%4 TEAMKILLED %1 with a missile!';
$DeathMessageTeamKill[$DamageType::Shocklance, 0] = '\c0%4 TEAMKILLED %1 with a shocklance!';
$DeathMessageTeamKill[$DamageType::Mine, 0] = '\c0%4 TEAMKILLED %1 with a mine!';
$DeathMessageTeamKill[$DamageType::SatchelCharge, 0] = '\c0%4 blew up TEAMMATE %1!';
$DeathMessageTeamKill[$DamageType::Impact, 0] = '\c0%4 runs down TEAMMATE %1!';
$DeathMessageTeamKill[$DamageType::Titan, 0] = '\c0%4 TEAMKILLED %1 with a titan chaingun!';
$DeathMessageTeamKill[$DamageType::Slug, 0] = '\c0%4 TEAMKILLED %1 with a slugrifle!';
$DeathMessageTeamKill[$DamageType::Nuke, 0] = '\c0%4 TEAMKILLED %1 with a widow maker!';
$DeathMessageTeamKill[$DamageType::Rail, 0] = '\c0%4 TEAMKILLED %1 with an RPG!';
$DeathMessageTeamKill[$DamageType::Railcan, 0] = '\c0%4 TEAMKILLED %1 with a rail cannon!';
$DeathMessageTeamKill[$DamageType::Antiag, 0] = '\c0%4 TEAMKILLED %1 with an anti air gun!';
$DeathMessageTeamKill[$DamageType::Nape, 0] = '\c0%4 TEAMKILLED %1 with napalm!';
$DeathMessageTeamKill[$DamageType::Storm, 0] = '\c0%4 TEAMKILLED %1 with a mortar storm!';
$DeathMessageTeamKill[$DamageType::Solar, 0] = '\c0%4 TEAMKILLED %1 with a solar charge!';
$DeathMessageTeamKill[$DamageType::Gatling, 0] = '\c0%4 TEAMKILLED %1 with a gatling gun!';
$DeathMessageTeamKill[$DamageType::Hornet, 0] = '\c0%4 TEAMKILLED %1 with a bazooka!';
$DeathMessageTeamKill[$DamageType::Hunt, 0] = '\c0%4 TEAMKILLED %1 with a head hunter!';
$DeathMessageTeamKill[$DamageType::Shotg, 0] = '\c0%4 TEAMKILLED %1 with a 12 gauge!';
$DeathMessageTeamKill[$DamageType::Saber, 0] = '\c0%4 TEAMKILLED %1 with a light saber!';
$DeathMessageTeamKill[$DamageType::Proton, 0] = '\c0%4 TEAMKILLED %1 with a dual proton blaster!';
$DeathMessageTeamKill[$DamageType::TimeBomb, 0] = '\c0%4 TEAMKILLED %1 with a time bomb!';
$DeathMessageTeamKill[$DamageType::Tactical, 0] = '\c0%4 TEAMKILLED %1 with a tactical nuke!';
$DeathMessageTeamKill[$DamageType::HLaser, 0] = '\c0%4 TEAMKILLED %1 with a heavy laser!';
$DeathMessageTeamKill[$DamageType::Lantern, 0] = '\c0%4 TEAMKILLED %1 with a Green Lantern!';

//these used when a player is killed by an enemy
$DeathMessageCount = 5;
$DeathMessage[$DamageType::Blaster, 0] = '\c0%4 kills %1 with a blaster.';
$DeathMessage[$DamageType::Blaster, 1] = '\c0%4 pings %1 to death.';
$DeathMessage[$DamageType::Blaster, 2] = '\c0%1 gets a pointer in blaster use from %4.';
$DeathMessage[$DamageType::Blaster, 3] = '\c0%4 fatally embarrasses %1 with %6 pea shooter.';
$DeathMessage[$DamageType::Blaster, 4] = '\c0%4 unleashes a terminal blaster barrage into %1.';

$DeathMessage[$DamageType::Plasma, 0] = '\c0%4 roasts %1 with the plasma rifle.';
$DeathMessage[$DamageType::Plasma, 1] = '\c0%4 gooses %1 with an extra-friendly burst of plasma.';
$DeathMessage[$DamageType::Plasma, 2] = '\c0%4 entices %1 to try a faceful of plasma.';
$DeathMessage[$DamageType::Plasma, 3] = '\c0%4 introduces %1 to the plasma immolation dance.';
$DeathMessage[$DamageType::Plasma, 4] = '\c0%4 slaps The Hot Kiss of Death on %1.';

$DeathMessage[$DamageType::Bullet, 0] = '\c0%4 rips %1 up with the chaingun.';
$DeathMessage[$DamageType::Bullet, 1] = '\c0%4 happily chews %1 into pieces with %6 chaingun.';
$DeathMessage[$DamageType::Bullet, 2] = '\c0%4 administers a dose of Vitamin Lead to %1.';
$DeathMessage[$DamageType::Bullet, 3] = '\c0%1 suffers a serious hosing from %4\'s chaingun.';
$DeathMessage[$DamageType::Bullet, 4] = '\c0%4 bestows the blessings of %6 chaingun on %1.';

$DeathMessage[$DamageType::Disc, 0] = '\c0%4 demolishes %1 with the spinfusor.';
$DeathMessage[$DamageType::Disc, 1] = '\c0%4 serves %1 a blue plate special.';
$DeathMessage[$DamageType::Disc, 2] = '\c0%4 shares a little blue friend with %1.';
$DeathMessage[$DamageType::Disc, 3] = '\c0%4 puts a little spin into %1.';
$DeathMessage[$DamageType::Disc, 4] = '\c0%1 becomes one of %4\'s greatest hits.';

$DeathMessage[$DamageType::Grenade, 0] = '\c0%4 eliminates %1 with a grenade.';   //applies to hand grenades *and* grenade launcher grenades
$DeathMessage[$DamageType::Grenade, 1] = '\c0%4 blows up %1 real good!';
$DeathMessage[$DamageType::Grenade, 2] = '\c0%1 gets annihilated by %4\'s grenade.';
$DeathMessage[$DamageType::Grenade, 3] = '\c0%1 receives a kaboom lesson from %4.';
$DeathMessage[$DamageType::Grenade, 4] = '\c0%4 turns %1 into grenade salad.'; 

$DeathMessage[$DamageType::Laser, 0] = '\c0%1 becomes %4\'s latest pincushion.';
$DeathMessage[$DamageType::Laser, 1] = '\c0%4 picks off %1 with %6 laser rifle.';
$DeathMessage[$DamageType::Laser, 2] = '\c0%4 uses %1 as the targeting dummy in a sniping demonstration.';						
$DeathMessage[$DamageType::Laser, 3] = '\c0%4 pokes a shiny new hole in %1 with %6 laser rifle.';
$DeathMessage[$DamageType::Laser, 4] = '\c0%4 caresses %1 with a couple hundred megajoules of laser.';

$DeathMessage[$DamageType::Elf, 0] = '\c0%4 fries %1 with the ELF projector.';
$DeathMessage[$DamageType::Elf, 1] = '\c0%4 bug zaps %1 with %6 ELF.';
$DeathMessage[$DamageType::Elf, 2] = '\c0%1 learns the shocking truth about %4\'s ELF skills.';
$DeathMessage[$DamageType::Elf, 3] = '\c0%4 electrocutes %1 without a sponge.';
$DeathMessage[$DamageType::Elf, 4] = '\c0%4\'s ELF projector leaves %1 a crispy critter.';

$DeathMessage[$DamageType::Mortar, 0] = '\c0%4 obliterates %1 with the mortar.';
$DeathMessage[$DamageType::Mortar, 1] = '\c0%4 drops a mortar round right in %1\'s lap.';
$DeathMessage[$DamageType::Mortar, 2] = '\c0%4 delivers a mortar payload straight to %1.';
$DeathMessage[$DamageType::Mortar, 3] = '\c0%4 offers a little "heavy love" to %1.';
$DeathMessage[$DamageType::Mortar, 4] = '\c0%1 stumbles into %4\'s mortar reticle.';

$DeathMessage[$DamageType::Missile, 0] = '\c0%4 intercepts %1 with a missile.';
$DeathMessage[$DamageType::Missile, 1] = '\c0%4 watches %6 missile touch %1 and go boom.';
$DeathMessage[$DamageType::Missile, 2] = '\c0%4 got sweet tone on %1.';
$DeathMessage[$DamageType::Missile, 3] = '\c0By now, %1 has realized %4\'s missile killed %2.';
$DeathMessage[$DamageType::Missile, 4] = '\c0%4\'s missile rains little pieces of %1 all over the ground.';

$DeathMessage[$DamageType::Shocklance, 0] = '\c0%4 reaps a harvest of %1 with the shocklance.';
$DeathMessage[$DamageType::Shocklance, 1] = '\c0%4 feeds %1 the business end of %6 shocklance.';
$DeathMessage[$DamageType::Shocklance, 2] = '\c0%4 stops %1 dead with the shocklance.';
$DeathMessage[$DamageType::Shocklance, 3] = '\c0%4 eliminates %1 in close combat.';
$DeathMessage[$DamageType::Shocklance, 4] = '\c0%4 ruins %1\'s day with one zap of a shocklance.';

$DeathMessage[$DamageType::Mine, 0] = '\c0%4 kills %1 with a mine.';
$DeathMessage[$DamageType::Mine, 1] = '\c0%1 doesn\'t see %4\'s mine in time.';
$DeathMessage[$DamageType::Mine, 2] = '\c0%4 gets a sapper kill on %1.';
$DeathMessage[$DamageType::Mine, 3] = '\c0%1 puts his foot on %4\'s mine.';
$DeathMessage[$DamageType::Mine, 4] = '\c0One small step for %1, one giant mine kill for %4.';

$DeathMessage[$DamageType::SatchelCharge, 0] = '\c0%4 buys %1 a ticket to the moon.';  //satchel charge only
$DeathMessage[$DamageType::SatchelCharge, 1] = '\c0%4 blows %1 into low orbit.';
$DeathMessage[$DamageType::SatchelCharge, 2] = '\c0%4 makes %1 a hugely explosive offer.';
$DeathMessage[$DamageType::SatchelCharge, 3] = '\c0%4 turns %1 into a cloud of satchel-vaporized armor.';
$DeathMessage[$DamageType::SatchelCharge, 4] = '\c0%4\'s satchel charge leaves %1 nothin\' but smokin\' boots.';

$DeathMessage[$DamageType::Titan, 0] = '\c0%4 rips %1 up with the titan chaingun.';
$DeathMessage[$DamageType::Titan, 1] = '\c0%4 happily chews %1 into pieces with %6 titan chaingun.';
$DeathMessage[$DamageType::Titan, 2] = '\c0%4 administers a dose of titan Lead to %1.';
$DeathMessage[$DamageType::Titan, 3] = '\c0%1 suffers a serious hosing from %4\'s titan chaingun.';
$DeathMessage[$DamageType::Titan, 4] = '\c0%4 bestows the blessings of %6 titan chaingun on %1.';

$DeathMessage[$DamageType::Slug, 0] = '\c0%4 wastes %1 with a slugrifle.';
$DeathMessage[$DamageType::Slug, 1] = '\c0%4 picks off %1 with %6 slugrifle.';
$DeathMessage[$DamageType::Slug, 2] = '\c0%4 uses %1 as a slug depository.';						
$DeathMessage[$DamageType::Slug, 3] = '\c0%4 blasts a gaping hole in %1 with %6 slugrifle.';
$DeathMessage[$DamageType::Slug, 4] = '\c0%4 gives %1 a lesson on slugrifle use, free of charge, what a guy!';

$DeathMessage[$DamageType::Nuke, 0] = '\c0%4 evaporates %1 with the widow maker.';
$DeathMessage[$DamageType::Nuke, 1] = '\c0%4 drops a widow maker on %1\'s helpless skull.';
$DeathMessage[$DamageType::Nuke, 2] = '\c0%4 delivers a widow maker straight to %1.';
$DeathMessage[$DamageType::Nuke, 3] = '\c0%4 kills %1 with the widow maker.';
$DeathMessage[$DamageType::Nuke, 4] = '\c0%1\'s corpse is hurtled skyward by %4\'s widow maker.';

$DeathMessage[$DamageType::Rail, 0] = '\c0%4 gets the drop on %1 with the RPG.';
$DeathMessage[$DamageType::Rail, 1] = '\c0%4 mails an RPG to %1 no postage necessary.';
$DeathMessage[$DamageType::Rail, 2] = '\c0%4 destroys %1 with the RPG.';
$DeathMessage[$DamageType::Rail, 3] = '\c0%4 kills %1 with the RPG.';
$DeathMessage[$DamageType::Rail, 4] = '\c0%1\'s carcass lays peacefully after being introduced to %4\'s RPG.';

$DeathMessage[$DamageType::Railcan, 0] = '\c0%4 finishes off %1 with the rail cannon.';
$DeathMessage[$DamageType::Railcan, 1] = '\c0%4 manages to actually kill %1 with %6 rail cannon.';
$DeathMessage[$DamageType::Railcan, 2] = '\c0%4 kills %1 with the rail cannon.';
$DeathMessage[$DamageType::Railcan, 3] = '\c0%4 uses %6 rail cannon to take that last bit of life from %1.';
$DeathMessage[$DamageType::Railcan, 4] = '\c0%4 somehow got a kill on %1 with the rail cannon.';

$DeathMessage[$DamageType::Antiag, 0] = '\c0%4 kills %1 with the anti air gun!';
$DeathMessage[$DamageType::Antiag, 1] = '\c0%4 kills %1 with the anti air gun, no easy feat.';
$DeathMessage[$DamageType::Antiag, 2] = '\c0%4 kills %1 with the anti air gun.';
$DeathMessage[$DamageType::Antiag, 3] = '\c0%4 kills %1 with the anti air gun, planes only hmm maybe not.';
$DeathMessage[$DamageType::Antiag, 4] = '\c0%4 surrounds %1 in lavender death.';

$DeathMessage[$DamageType::Nape, 0] = '\c0%4 cooks %1 with napalm, mmm tasty.';
$DeathMessage[$DamageType::Nape, 1] = '\c0%4 torches %1 with some napalm.';
$DeathMessage[$DamageType::Nape, 2] = '\c0%4 shows %1 how it feels to burn.';
$DeathMessage[$DamageType::Nape, 3] = '\c0%4 gives %1 an all over tan, with %6 napalm.';
$DeathMessage[$DamageType::Nape, 4] = '\c0%4 loves the smell of napalm in the morning, %1 probably doesnt.';

$DeathMessage[$DamageType::Storm, 0] = '\c0%1 gets caught in %4\'s mortar storm.';
$DeathMessage[$DamageType::Storm, 1] = '\c0%4 kills %1 with a mortar storm.';
$DeathMessage[$DamageType::Storm, 2] = '\c0%4 unleashes the fury of the mortar storm on %1.';
$DeathMessage[$DamageType::Storm, 3] = '\c0%4 gives %1 a front row ticket to the perfect storm.';
$DeathMessage[$DamageType::Storm, 4] = '\c0%4 leaves %1 nowhere to hide with %6 mortar storm.';

$DeathMessage[$DamageType::Solar, 0] = '\c0%1 gets destroyed by %4\'s solar charge.';
$DeathMessage[$DamageType::Solar, 1] = '\c0%4 kills %1 with a solar charge.';
$DeathMessage[$DamageType::Solar, 2] = '\c0%4 vaporizes %1 with the solar charge.';
$DeathMessage[$DamageType::Solar, 3] = '\c0%4 fries %1 with %6 solar charge.';
$DeathMessage[$DamageType::Solar, 4] = '\c0%4 annihilates %1 with solar power.';

$DeathMessage[$DamageType::Gatling, 0] = '\c0%4 rips %1 up with the gatling gun.';
$DeathMessage[$DamageType::Gatling, 1] = '\c0%4 shreds %1 to pieces with %6 gatling gun.';
$DeathMessage[$DamageType::Gatling, 2] = '\c0%4 kills %1 with %6 gatling gun.';
$DeathMessage[$DamageType::Gatling, 3] = '\c0%1 suffers a barrage of lead from %4\'s gatling gun.';
$DeathMessage[$DamageType::Gatling, 4] = '\c0%4 fills %1 full of holes with the gatling gun.';

$DeathMessage[$DamageType::Hornet, 0] = '\c0%4 buries %1 with the bazooka.';
$DeathMessage[$DamageType::Hornet, 1] = '\c0%4 ends %1\'s life with a bazooka blast.';
$DeathMessage[$DamageType::Hornet, 2] = '\c0%4 kills %1 with %6 bazooka.';
$DeathMessage[$DamageType::Hornet, 3] = '\c0%1 could not escape from %4\'s bazooka.';
$DeathMessage[$DamageType::Hornet, 4] = '\c0%1 meets %4\'s bazooka shell up close and personal.';

$DeathMessage[$DamageType::Hunt, 0] = '\c0%4 caves in %1\'s skull with %6 head hunter.';
$DeathMessage[$DamageType::Hunt, 1] = '\c0%4 shatters %1\'s cranium with the head hunter.';
$DeathMessage[$DamageType::Hunt, 2] = '\c0%1 has his brain replaced with %4\'s head hunter projectile.';						
$DeathMessage[$DamageType::Hunt, 3] = '\c0%4 caves in %1\'s skull with %6 head hunter.';
$DeathMessage[$DamageType::Hunt, 4] = '\c0%4 shatters %1\'s cranium with the head hunter.';

$DeathMessage[$DamageType::Shotg, 0] = '\c0%4 destroys %1 with the 12 gauge.';
$DeathMessage[$DamageType::Shotg, 1] = '\c0%4 kills %1 with the 12 gauge.';
$DeathMessage[$DamageType::Shotg, 2] = '\c0%4 uses the 12 gauge to finish off %1.';
$DeathMessage[$DamageType::Shotg, 3] = '\c0%1 gets pelted to death by %4\'s 12 gauge.';
$DeathMessage[$DamageType::Shotg, 4] = '\c0%4 pumps %1 full of 12 gauge buck shot.';

$DeathMessage[$DamageType::Saber, 0] = '\c0%4 kills %1 with a light saber.';
$DeathMessage[$DamageType::Saber, 1] = '\c0%4 gives %1 an obi wan special.';
$DeathMessage[$DamageType::Saber, 2] = '\c0%1 is vaporized by %4\'s light saber.';
$DeathMessage[$DamageType::Saber, 3] = '\c0%1 gets a lesson in swordplay from %4\'s light saber.';
$DeathMessage[$DamageType::Saber, 4] = '\c0%4 goes jedi on %1.';

$DeathMessage[$DamageType::Proton, 0] = '\c0%4 kills %1 with a dual proton blaster.';
$DeathMessage[$DamageType::Proton, 1] = '\c0%4 uses the proton blaster on %1 like a pro.';
$DeathMessage[$DamageType::Proton, 2] = '\c0%1 takes one too many from %4\'s proton blaster.';
$DeathMessage[$DamageType::Proton, 3] = '\c0%4 rips through %1 with a dual proton blaster.';
$DeathMessage[$DamageType::Proton, 4] = '\c0%4 displays the power of the proton on %1.';

$DeathMessage[$DamageType::TimeBomb, 0] = '\c0%4 kills %1 with a time bomb.';
$DeathMessage[$DamageType::TimeBomb, 1] = '\c0%4 blows %1 to pieces with a time bomb.';
$DeathMessage[$DamageType::TimeBomb, 2] = '\c0%1 stumbles into %4\'s time bomb blast.';
$DeathMessage[$DamageType::TimeBomb, 3] = '\c0%4 batters %1 with a time bomb explosive.';
$DeathMessage[$DamageType::TimeBomb, 4] = '\c0%1 stumbles into %4\'s time bomb blast.';

$DeathMessage[$DamageType::Tactical, 0] = '\c0%4 kills %1 with a tactical nuke.';
$DeathMessage[$DamageType::Tactical, 1] = '\c0%4 vaporizes %1 with a tactical nuke.';
$DeathMessage[$DamageType::Tactical, 2] = '\c0%1\'s life comes to a violent end, thanks to %4\'s tactical nuke.';
$DeathMessage[$DamageType::Tactical, 3] = '\c0%4 surpises %1 with a tactical nuke blast.';
$DeathMessage[$DamageType::Tactical, 4] = '\c0%1 gets hurt... badly by %4\'s tactical nuke.';

$DeathMessage[$DamageType::HLaser, 0] = '\c0%1 becomes %4\'s latest X-3 laser depository.';
$DeathMessage[$DamageType::HLaser, 1] = '\c0%4 picks off %1 with %6 X-3 Laser rifle.';
$DeathMessage[$DamageType::HLaser, 2] = '\c0%4 kills %1 with %6 X3 laser rifle.';						
$DeathMessage[$DamageType::HLaser, 3] = '\c0%4 pokes a shiny new hole in %1 with %6 X-3 Laser rifle.';
$DeathMessage[$DamageType::HLaser, 4] = '\c0%4 caresses %1 with a couple million megajoules of X-3 laser.';

$DeathMessage[$DamageType::Lantern, 0] = '\c0%4 kills %1 with the green lantern.';
$DeathMessage[$DamageType::Lantern, 1] = '\c0%4 vaporizes %1 with a green lantern blast.';
$DeathMessage[$DamageType::Lantern, 2] = '\c0%1 next time it might be a good idea to move away from the sparkly green ball.';
$DeathMessage[$DamageType::Lantern, 3] = '\c0%4 devastates %1 with the green lantern.';
$DeathMessage[$DamageType::Lantern, 4] = '\c0%1 got a little too close to %4\'s green lantern.';

$DeathMessageHeadshotCount = 3;
$DeathMessageHeadshot[$DamageType::Laser, 0] = '\c0%4 drills right through %1\'s braincase with %6 laser.';
$DeathMessageHeadshot[$DamageType::Laser, 1] = '\c0%4 pops %1\'s head like a cheap balloon.';
$DeathMessageHeadshot[$DamageType::Laser, 2] = '\c0%1 loses %3 head over %4\'s laser skill.';

$DeathMessageHeadshot[$DamageType::Hunt, 0] = '\c0%4 caves in %1\'s skull with %6 head hunter.';
$DeathMessageHeadshot[$DamageType::Hunt, 1] = '\c0%4 shatters %1\'s cranium with the head hunter.';
$DeathMessageHeadshot[$DamageType::Hunt, 2] = '\c0%1 has his brain replaced with %4\'s head hunter projectile.';

$DeathMessageHeadshot[$DamageType::HLaser, 0] = '\c0%4 drills right through %1\'s braincase with %6 X-3 laser.';
$DeathMessageHeadshot[$DamageType::HLaser, 1] = '\c0%4 pops %1\'s head like a cheap balloon.';
$DeathMessageHeadshot[$DamageType::HLaser, 2] = '\c0%1 loses %3 head over %4\'s X-3 laser skill.';
 
//These used when a player is run over by a vehicle
$DeathMessageVehicleCount = 5;
$DeathMessageVehicle[0] = '\c0%4 runs down %1.';
$DeathMessageVehicle[1] = '\c0%1 acquires that run-down feeling from %4.';
$DeathMessageVehicle[2] = '\c0%4 transforms %1 into tribal roadkill.';
$DeathMessageVehicle[3] = '\c0%1 makes a painfully close examination of %4\'s front bumper.';
$DeathMessageVehicle[4] = '\c0%1\'s messy death leaves a mark on %4\'s vehicle finish.';

$DeathMessageVehicleCrashCount = 5;
$DeathMessageVehicleCrash[ $DamageType::Crash, 0 ] = '\c0%1 fails to eject in time.';
$DeathMessageVehicleCrash[ $DamageType::Crash, 1 ] = '\c0%1 becomes one with his vehicle dashboard.';
$DeathMessageVehicleCrash[ $DamageType::Crash, 2 ] = '\c0%1 drives under the influence of death.';
$DeathMessageVehicleCrash[ $DamageType::Crash, 3 ] = '\c0%1 makes a perfect three hundred point landing.';
$DeathMessageVehicleCrash[ $DamageType::Crash, 4 ] = '\c0%1 heroically pilots his vehicle into something really, really hard.';

$DeathMessageVehicleFriendlyCount = 3;
$DeathMessageVehicleFriendly[0] = '\c0%1 gets in the way of a friendly vehicle.';
$DeathMessageVehicleFriendly[1] = '\c0Sadly, a friendly vehicle turns %1 into roadkill.';
$DeathMessageVehicleFriendly[2] = '\c0%1 becomes an unsightly ornament on a team vehicle\'s hood.';

$DeathMessageVehicleUnmannedCount = 3;
$DeathMessageVehicleUnmanned[0] = '\c0%1 gets in the way of a runaway vehicle.';
$DeathMessageVehicleUnmanned[1] = '\c0An unmanned vehicle kills the pathetic %1.';
$DeathMessageVehicleUnmanned[2] = '\c0%1 is struck down by an empty vehicle.';

//These used when a player is killed by a nearby equipment explosion
$DeathMessageExplosionCount = 3;
$DeathMessageExplosion[0] = '\c0%1 was killed by exploding equipment!';
$DeathMessageExplosion[1] = '\c0%1 stood a little too close to the action!';
$DeathMessageExplosion[2] = '\c0%1 learns how to be collateral damage.';

//These used when an automated turret kills an  enemy player
$DeathMessageTurretKillCount = 3;
$DeathMessageTurretKill[$DamageType::PlasmaTurret, 0] = '\c0%1 is killed by a plasma turret.';
$DeathMessageTurretKill[$DamageType::PlasmaTurret, 1] = '\c0%1\'s body now marks the location of a plasma turret.';
$DeathMessageTurretKill[$DamageType::PlasmaTurret, 2] = '\c0%1 is fried by a plasma turret.';

$DeathMessageTurretKill[$DamageType::AATurret, 0] = '\c0%1 is killed by an AA turret.';
$DeathMessageTurretKill[$DamageType::AATurret, 1] = '\c0%1 is shot down by an AA turret.';
$DeathMessageTurretKill[$DamageType::AATurret, 2] = '\c0%1 takes fatal flak from an AA turret.';

$DeathMessageTurretKill[$DamageType::ElfTurret, 0] = '\c0%1 is killed by an ELF turret.';
$DeathMessageTurretKill[$DamageType::ElfTurret, 1] = '\c0%1 is zapped by an ELF turret.';
$DeathMessageTurretKill[$DamageType::ElfTurret, 2] = '\c0%1 is short-circuited by an ELF turret.';

$DeathMessageTurretKill[$DamageType::MortarTurret, 0] = '\c0%1 is killed by a mortar turret.';
$DeathMessageTurretKill[$DamageType::MortarTurret, 1] = '\c0%1 enjoys a mortar turret\'s attention.';
$DeathMessageTurretKill[$DamageType::MortarTurret, 2] = '\c0%1 is blown to kibble by a mortar turret.';

$DeathMessageTurretKill[$DamageType::MissileTurret, 0] = '\c0%1 is killed by a missile turret.';
$DeathMessageTurretKill[$DamageType::MissileTurret, 1] = '\c0%1 is shot down by a missile turret.';
$DeathMessageTurretKill[$DamageType::MissileTurret, 2] = '\c0%1 is blown away by a missile turret.';

$DeathMessageTurretKill[$DamageType::IndoorDepTurret, 0] = '\c0%1 is killed by a triumph clamp turret.';
$DeathMessageTurretKill[$DamageType::IndoorDepTurret, 1] = '\c0%1 gets burned by a triumph clamp turret.';
$DeathMessageTurretKill[$DamageType::IndoorDepTurret, 2] = '\c0A triumph clamp turret eliminates %1.';

$DeathMessageTurretKill[$DamageType::OutdoorDepTurret, 0] = '\c0A triumph spike turret neatly drills %1.';
$DeathMessageTurretKill[$DamageType::OutdoorDepTurret, 1] = '\c0%1 gets taken out by a triumph spike turret.';
$DeathMessageTurretKill[$DamageType::OutdoorDepTurret, 2] = '\c0%1 dies under a triumph spike turret\'s love.';

$DeathMessageTurretKill[$DamageType::SentryTurret, 0] = '\c0%1 didn\'t see that Sentry turret, but it saw %2...';
$DeathMessageTurretKill[$DamageType::SentryTurret, 1] = '\c0%1 needs to watch for Sentry turrets.';
$DeathMessageTurretKill[$DamageType::SentryTurret, 2] = '\c0%1 now understands how Sentry turrets work.';

$DeathMessageTurretKill[$DamageType::Tlaser, 0] = '\c0A laser spike turret kills %1.';
$DeathMessageTurretKill[$DamageType::Tlaser, 1] = '\c0%1 gets taken out by a laser spike turret.';
$DeathMessageTurretKill[$DamageType::Tlaser, 2] = '\c0%1 is killed by a laser spike turret.';


//used when a player is killed by a teammate controlling a turret
$DeathMessageCTurretTeamKillCount = 1;	
$DeathMessageCTurretTeamKill[$DamageType::PlasmaTurret, 0] = '\c0%4 TEAMKILLED %1 with a plasma turret!';

$DeathMessageCTurretTeamKill[$DamageType::AATurret, 0] = '\c0%4 TEAMKILLED %1 with an AA turret!';

$DeathMessageCTurretTeamKill[$DamageType::ELFTurret, 0] = '\c0%4 TEAMKILLED %1 with an ELF turret!';

$DeathMessageCTurretTeamKill[$DamageType::MortarTurret, 0] = '\c0%4 TEAMKILLED %1 with a mortar turret!';

$DeathMessageCTurretTeamKill[$DamageType::MissileTurret, 0] = '\c0%4 TEAMKILLED %1 with a missile turret!';

$DeathMessageCTurretTeamKill[$DamageType::IndoorDepTurret, 0] = '\c0%4 TEAMKILLED %1 with a triumph clamp turret!';

$DeathMessageCTurretTeamKill[$DamageType::OutdoorDepTurret, 0] = '\c0%4 TEAMKILLED %1 with a triumph spike turret!';

$DeathMessageCTurretTeamKill[$DamageType::SentryTurret, 0] = '\c0%4 TEAMKILLED %1 with a sentry turret!';

$DeathMessageCTurretTeamKill[$DamageType::BomberBombs, 0] = '\c0%4 TEAMKILLED %1 in a bombastic explosion of raining death.';

$DeathMessageCTurretTeamKill[$DamageType::BellyTurret, 0] = '\c0%4 TEAMKILLED %1 by annihilating him from a belly turret.';

$DeathMessageCTurretTeamKill[$DamageType::TankChainGun, 0] = '\c0%4 TEAMKILLED %1 with his tank\'s chaingun.';

$DeathMessageCTurretTeamKill[$DamageType::TankMortar, 0] = '\c0%4 TEAMKILLED %1 by lobbing the BIG green death from a tank.'; 

$DeathMessageCTurretTeamKill[$DamageType::ShrikeBlaster, 0] = '\c0%4 TEAMKILLED %1 by strafing from a Shrike.';

$DeathMessageCTurretTeamKill[$DamageType::MPBMissile, 0] = '\c0%4 TEAMKILLED %1 when the MPB locked onto him.';

$DeathMessageCTurretTeamKill[$DamageType::Hog, 0] = '\c0%4 TEAMKILLED %1 using a wart hog flyer.';

$DeathMessageCTurretTeamKill[$DamageType::OutdoorDepTurret, 0] = '\c0%4 TEAMKILLED %1 with a laser spike turret!';

 

//used when a player is killed by an uncontrolled, friendly turret
$DeathMessageCTurretAccdtlKillCount = 1; 
$DeathMessageCTurretAccdtlKill[$DamageType::PlasmaTurret, 0] = '\c0%1 got in the way of a plasma turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::AATurret, 0] = '\c0%1 got in the way of an AA turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::ELFTurret, 0] = '\c0%1 got in the way of an ELF turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::MortarTurret, 0] = '\c0%1 got in the way of a mortar turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::MissileTurret, 0] = '\c0%1 got in the way of a missile turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::IndoorDepTurret, 0] = '\c0%1 got in the way of a triumph clamp turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::OutdoorDepTurret, 0] = '\c0%1 got in the way of a triumph spike turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::SentryTurret, 0] = '\c0%1 got in the way of a Sentry turret!';

$DeathMessageCTurretAccdtlKill[$DamageType::Tlaser, 0] = '\c0%1 got in the way of a laser spike turret!';


//these messages for owned or controlled turrets
$DeathMessageCTurretKillCount = 3;
$DeathMessageCTurretKill[$DamageType::PlasmaTurret, 0] = '\c0%4 torches %1 with a plasma turret!'; 
$DeathMessageCTurretKill[$DamageType::PlasmaTurret, 1] = '\c0%4 fries %1 with a plasma turret!';
$DeathMessageCTurretKill[$DamageType::PlasmaTurret, 2] = '\c0%4 lights up %1 with a plasma turret!';

$DeathMessageCTurretKill[$DamageType::AATurret, 0] = '\c0%4 shoots down %1 with an AA turret.';
$DeathMessageCTurretKill[$DamageType::AATurret, 1] = '\c0%1 gets shot down by %1\'s AA turret.';
$DeathMessageCTurretKill[$DamageType::AATurret, 2] = '\c0%4 takes out %1 with an AA turret.';

$DeathMessageCTurretKill[$DamageType::ElfTurret, 0] = '\c0%1 gets zapped by ELF gunner %4.';
$DeathMessageCTurretKill[$DamageType::ElfTurret, 1] = '\c0%1 gets barbecued by ELF gunner %4.';
$DeathMessageCTurretKill[$DamageType::ElfTurret, 2] = '\c0%1 gets shocked by ELF gunner %4.';

$DeathMessageCTurretKill[$DamageType::MortarTurret, 0] = '\c0%1 is annihilated by %4\'s mortar turret.';
$DeathMessageCTurretKill[$DamageType::MortarTurret, 1] = '\c0%1 is blown away by %4\'s mortar turret.';
$DeathMessageCTurretKill[$DamageType::MortarTurret, 2] = '\c0%1 is pureed by %4\'s mortar turret.';

$DeathMessageCTurretKill[$DamageType::MissileTurret, 0] = '\c0%4 shows %1 a new world of pain with a missile turret.';
$DeathMessageCTurretKill[$DamageType::MissileTurret, 1] = '\c0%4 pops %1 with a missile turret.';
$DeathMessageCTurretKill[$DamageType::MissileTurret, 2] = '\c0%4\'s missile turret lights up %1\'s, uh, ex-life.';

$DeathMessageCTurretKill[$DamageType::IndoorDepTurret, 0] = '\c0%1 is chewed up and spat out by %4\'s triumph clamp turret.';
$DeathMessageCTurretKill[$DamageType::IndoorDepTurret, 1] = '\c0%1 is knocked out by %4\'s triumph clamp turret.';
$DeathMessageCTurretKill[$DamageType::IndoorDepTurret, 2] = '\c0%4\'s triumph clamp turret drills %1 nicely.';

$DeathMessageCTurretKill[$DamageType::OutdoorDepTurret, 0] = '\c0%1 is chewed up by %4\'s triumph spike turret.';
$DeathMessageCTurretKill[$DamageType::OutdoorDepTurret, 1] = '\c0%1 feels the burn from %4\'s triumph spike turret.';
$DeathMessageCTurretKill[$DamageType::OutdoorDepTurret, 2] = '\c0%1 is nailed by %4\'s triumph spike turret.';

$DeathMessageCTurretKill[$DamageType::SentryTurret, 0] = '\c0%4 caught %1 by surprise with a turret.';
$DeathMessageCTurretKill[$DamageType::SentryTurret, 1] = '\c0%4\'s turret took out %1.';
$DeathMessageCTurretKill[$DamageType::SentryTurret, 2] = '\c0%4 blasted %1 with a turret.';

$DeathMessageCTurretKill[$DamageType::BomberBombs, 0] = '\c0%1 catches %4\'s bomb in both teeth.'; 
$DeathMessageCTurretKill[$DamageType::BomberBombs, 1] = '\c0%4 leaves %1 a smoking bomb crater.'; 
$DeathMessageCTurretKill[$DamageType::BomberBombs, 2] = '\c0%4 bombs %1 back to the 20th century.';

$DeathMessageCTurretKill[$DamageType::BellyTurret, 0] = '\c0%1 eats a big helping of %4\'s belly turret bolt.';
$DeathMessageCTurretKill[$DamageType::BellyTurret, 1] = '\c0%4 plants a belly turret bolt in %1\'s belly.';
$DeathMessageCTurretKill[$DamageType::BellyTurret, 2] = '\c0%1 fails to evade %4\'s deft bomber strafing.';

$DeathMessageCTurretKill[$DamageType::TankChainGun, 0] = '\c0%1 enjoys the rich, metallic taste of %4\'s tank slug.';
$DeathMessageCTurretKill[$DamageType::TankChainGun, 1] = '\c0%4\'s tank chaingun plays sweet music all over %1.';
$DeathMessageCTurretKill[$DamageType::TankChainGun, 2] = '\c0%1 receives a stellar exit wound from %4\'s tank slug.';

$DeathMessageCTurretKill[$DamageType::TankMortar, 0] = '\c0Whoops! %1 + %4\'s tank mortar = Dead %1.';
$DeathMessageCTurretKill[$DamageType::TankMortar, 1] = '\c0%1 learns the happy explosion dance from %4\'s tank mortar.';
$DeathMessageCTurretKill[$DamageType::TankMortar, 2] = '\c0%4\'s tank mortar has a blast with %1.';

$DeathMessageCTurretKill[$DamageType::ShrikeBlaster, 0] = '\c0%1 dines on a Shrike blaster sandwich, courtesy of %4.';
$DeathMessageCTurretKill[$DamageType::ShrikeBlaster, 1] = '\c0The blaster of %4\'s Shrike turns %1 into finely shredded meat.';
$DeathMessageCTurretKill[$DamageType::ShrikeBlaster, 2] = '\c0%1 gets drilled big-time by the blaster of %4\'s Shrike.';

$DeathMessageCTurretKill[$DamageType::MPBMissile, 0] = '\c0%1 intersects nicely with %4\'s MPB Missile.';
$DeathMessageCTurretKill[$DamageType::MPBMissile, 1] = '\c0%4\'s MPB Missile makes armored chowder out of %1.';
$DeathMessageCTurretKill[$DamageType::MPBMissile, 2] = '\c0%1 has a brief, explosive fling with %4\'s MPB Missile.';

$DeathMessageCTurretKill[$DamageType::Hog, 0] = '\c0%4 pulverizes %1 with some wart hog mortars.';
$DeathMessageCTurretKill[$DamageType::Hog, 1] = '\c0%4\'s Hog mortar obliterates %1.';
$DeathMessageCTurretKill[$DamageType::Hog, 2] = '\c0%1 gets hogtied by %4\'s wart hog skills.';

$DeathMessageCTurretKill[$DamageType::Tlaser, 0] = '\c0%1 is killed by %4\'s laser spike turret.';
$DeathMessageCTurretKill[$DamageType::Tlaser, 1] = '\c0%1 gets sniped by %4\'s laser spike turret.';
$DeathMessageCTurretKill[$DamageType::Tlaser, 2] = '\c0%1 is nailed by %4\'s laser spike turret.';

$DeathMessageTurretSelfKillCount = 3;
$DeathMessageTurretSelfKill[0] = '\c0%1 somehow kills %2self with a turret.';
$DeathMessageTurretSelfKill[1] = '\c0%1 apparently didn\'t know the turret was loaded.';
$DeathMessageTurretSelfKill[2] = '\c0%1 helps his team by killing himself with a turret.';



